
#include <iostream>
#include "abstractElement.h"

abstractElement::abstractElement() 
{
  setDefaultValues();
  setDefaults();
  stepmaxcm_ = 1000000;
}

abstractElement::abstractElement(string lab)
{
  label_ = lab;
  setDefaultValues();
  setDefaults();
  stepmaxcm_ = 1000000;
}

abstractElement::~abstractElement() 
{
  if (parametersString_ != NULL) delete [] parametersString_ ;
}

void abstractElement::setDefaultValues() 
{
  defaultLabel_ = string("XXXXXX");
  defaultLength_ = 0.0;
  defaultAperture_ = 1.e+6;
  phaseStepMax_ = 10.;
}

void abstractElement::setDefaults() 
{
  label_ = defaultLabel_;
  nbParam_ = 2;
  lenghtElem_ = defaultLength_;
  aperture_ = defaultAperture_;
}

void abstractElement::setPhaseStep(double) { 
  cout << " setPhaseStep : ce n'est pas celui la qu'il faut ! " ; 
  return;
}

void abstractElement::setParameters(double ll, double aper) 
{
  lenghtElem_ = ll;
  aperture_ = aper;
}

void abstractElement::setLabel(string lab)
{
  label_= lab;
}

string abstractElement::getLabel() const
{
  return label_;
}


nomdElements abstractElement::getNomdElement() const 
{
  return elementName_;
}



double abstractElement::getLenghtOfElement() const { 
  return lenghtElem_;
}

int abstractElement::getNbParams() const {
  return nbParam_;
}

trivaluedBool abstractElement::is_accepted_by_software(nomDeLogiciel soft) const {
  cout << " abstractElement : generic method is_accepted_by_software()  " << endl;
  return error;
}

double abstractElement::getInitialKineticEnergy() const {
  return 0.0;
}


string abstractElement::generatorOutputFlow() const {
  return "";
}
